<template>
  <q-page padding class="height-0 column">
    <div class="column full-height">
      <q-scroll-area class="col" :thumb-style="{right: '0', borderRadius: '4px', background: '#d12', opacity: .6, width: '10px'}">
        <q-collapsible label="Details" :value="true" header-class="q-title">
          <q-input v-model="config.title" class="shadow-2 q-pa-sm q-mb-md bg-white" hide-underline float-label="Channel Title" />
          <q-input type="textarea" v-model="config.description" class="shadow-2 q-pa-sm q-mb-md bg-white" hide-underline clearable float-label="Channel Description" />
          <div class="row gutter-sm q-mb-md">
            <div class="col-12 col-sm">
              <q-toggle v-model="config.publish" label="Show on Home Page" :true-value="1" :false-value="0" />
            </div>
            <div class="col-12 col-sm">
              <q-toggle v-model="config.featured" label="Featured" :true-value="1" :false-value="0" />
            </div>
          </div>
          <q-datetime type="date" v-model="config.eventDate" format-model="date" class="shadow-2 q-pa-sm q-mb-md bg-white" hide-underline float-label="Event Date" />
          <google-autocomplete :value="config.gmapData.address" class="shadow-2 q-pa-sm q-mb-md bg-white" hide-underline float-label="Please type your address" @placechanged="geolocationChanged" />
          <q-field :label="`Map Zoom Level: ${ config.gmapData.zoom }`" :label-width="4">
            <q-slider v-model="config.gmapData.zoom" :min="1" :max="23" class="shadow-2 q-pa-sm q-mb-md bg-white" label snap />
          </q-field>
          <q-field :label="`${ config.gmapData.latitude }, ${ config.gmapData.longitude }`" :label-width="4">
            <div class="text-center">
              <img class="shadow-2 preview" :src="mapPreviewUrl" />
            </div>
          </q-field>
          <q-input v-model="config.iframeContainerUrl" class="shadow-2 q-pa-sm q-mb-md bg-white" hide-underline clearable float-label="IFrame Container URL" />
        </q-collapsible>
        <q-collapsible label="Media Content" :value="true" header-class="q-title">
          <div class="row items-start justify-between no-wrap gutter-xs q-my-md" v-for="meta in metas" :key="meta.id">
            <div class="col-12 col-sm-4 relative-position">
              <q-btn class="full-width" no-caps color="primary" @click="filePick(meta.id)" :disable="!fileCanAdd(meta.id)" :label="meta.name" />
              <input type="file" :ref="`file_${ meta.id }`"
                class="q-uploader-input absolute-full cursor-pointer"
                :accept="meta.extensions"
                :multiple="meta.multiple"
                @change="fileAdd($event, meta)"
              />
            </div>
            <div class="col-12 col-sm-8">
              <img v-if="!files[meta.id].length && config[meta.id]" class="shadow-2 preview" :src="config[meta.id]" />
              <template v-if="files[meta.id].length">
                <div v-for="file in files[meta.id]" :key="file.__fileId" class="q-mb-md">
                  <div>
                    <div class="row q-pa-sm">
                      <q-icon v-if="file.__doneUploading && !file.__failed" name="check" color="positive" />
                      <q-btn v-if="!uploading" round dense size="sm" icon="clear" color="faded" @click="fileRemove(meta.id, file)" />
                      <div class="col q-px-xs">
                        {{file.name}}
                      </div>
                      <q-btn v-if="!uploading" round dense size="sm" icon="crop" color="primary" title="Crop" @click="selectForCrop(meta, file)" />
                    </div>
                    <div v-if="uploading" class="q-my-sm">
                      <q-progress animate
                        :color="file.__failed ? 'negative' : (file.__doneUploading ? 'positive' : 'warning')"
                        :percentage="file.__checksum ? file.__progress : file.__progress_checksum"
                      ></q-progress>
                    </div>
                  </div>
                  <div class="row gutter-sm">
                    <div class="col-12 col-md">
                      Original
                      <div class="shadow-2 q-pa-xs">
                        <img class="preview" :src="file.__img" />
                      </div>
                    </div>
                    <div class="col-12 col-md">
                      Cropped
                      <div class="shadow-2 q-pa-xs">
                        <img class="preview" :src="file.__imgCrop" />
                      </div>
                    </div>
                  </div>
                </div>
              </template>
            </div>
          </div>
          <div v-show="cropData.showCrop" class="text-center q-pt-sm shadow-2 bg-white">
            <image-cropper v-model="croppa" :initial-image="cropData.image"
              disable-click-to-choose
              disable-drag-and-drop
              prevent-white-space
              :show-remove-button="false"
              :width="cropData.width"
              :height="cropData.height"
              :quality="cropData.quality"
            />
            <div class="row gutter-sm">
              <div class="col">
                <q-btn color="faded" flat dense class="full-width" label="Cancel" @click="cropData.showCrop = false" />
              </div>
              <div class="col">
                <q-btn color="primary" flat dense class="full-width" label="Save Crop" @click="saveCrop()" />
              </div>
            </div>
          </div>
        </q-collapsible>
        <q-collapsible label="Analytics" :value="true" header-class="q-title">
          <q-input v-model="config.gaCode" class="shadow-2 q-pa-sm q-mb-md bg-white" hide-underline float-label="GA Code" />
          <q-input v-model="config.dashboardUrl" class="shadow-2 q-pa-sm q-mb-md bg-white" hide-underline clearable float-label="Dashboard Url" />
        </q-collapsible>
        <q-collapsible label="Interactive (in Video) Ad" :value="true" header-class="q-title">
          <q-input v-model="config.adConfig.adTagUrl" class="shadow-2 q-pa-sm q-mb-md bg-white" hide-underline float-label="Ad URL (VAST Configuration URL)" />
          <q-toggle v-model="config.adConfig.skipButton" label="Show Skip Button" :true-value="defaultAdSkipButton" :false-value="''" />
        </q-collapsible>
      </q-scroll-area>
      <q-btn no-caps color="primary" label="Save Channel Info" @click="saveConfig" :loading="uploading" class="full-width q-mt-md" />
    </div>
  </q-page>
</template>

<style lang="stylus">
  img.preview
    display block
    max-width 100%
    height auto
    max-height 20vh
    border-radius 5px
    margin auto
</style>

<script>
  import {
    format,
    clone,
    extend,
    uid,
  } from 'quasar';
  import asmCrypto from 'asmcrypto.js';
  import { CancelToken, isCancel } from 'axios';
  import { mapState } from 'vuex';
  import { stringify } from 'qs';
  import { getRejectionMessage, showRejectionMessage } from '../../utils';
  import GoogleAutocomplete from '../google-autocomplete/google-autocomplete';
  import { googleMapsId } from '../../config';

  const { humanStorageSize } = format;
  const chunkSize = 5 * 1024 * 1024;
  const chunkMaxCount = 2;
  const reRange = /(?:bytes=)?\d+-(\d+)$/;
  let fileIdef = 0;

  function parseEndpoint(endpoint) {
    if (/^(https?:)?\/\//.test(endpoint)) return endpoint;
    return endpoint.replace('/video-processor-secured/', '');
  }

  function parseRange(range) {
    const r = reRange.exec(range);
    return r ? parseInt(r[1], 10) + 1 : 0;
  }

  const langs = [
    { id: 'en', name: 'English' },
    { id: 'de', name: 'Deutsch' },
    { id: 'fr', name: 'Francais' },
    { id: 'it', name: 'Italiano' },
    { id: 'es', name: 'Español' },
    { id: 'pl', name: 'Polish' },
    { id: 'tr', name: 'Turkish' },
    { id: 'br', name: 'Português' },
  ];

  const defaultAdSkipButton = '<div class="skipButton">skip ad</div>';

  const defaultAdConfig = {
    companion: 'companionAd',
    companionSize: [[728, 90], [242, 30]],
    network: '6062',
    unitPath: 'iab_vast_samples',
    adTagUrl: '',
    skipButton: '',
  };

  const defaultConfig = {
    title: '', // langs.reduce((acc, lang) => { acc[lang.id] = ''; return acc; }, {}),
    description: '',
    eventDate: new Date(),
    gmapData: {
      mapTypeId: 'roadmap',
      zoom: 16,
      latitude: 0,
      longitude: 0,
      address: '',
    },

    bannerUrl: '',
    pictureUrl: '',
    demoVideoId: null,

    publish: 0,
    featured: 0,
    channelType: 1,
    status: 1,
    categoryId: 1,

    dashboardUrl: null,
    gaCode: 'UA-43608838-6',

    demo_thumbnail_url: null,

    iframeHtmlCode: null,
    iframeContainerUrl: null,

    shareTemplateKey: 'USER_SHARE_VIDEO_GENERAL',
    sendgridCredentialsId: null,
    adConfig: clone(defaultAdConfig),
  };

  const metas = [
    {
      id: 'bannerUrl',
      name: 'Banner Image',
      type: 'IMAGE',
      extensions: 'image/*',
      multiple: false,
      width: 1140,
      height: 300,
      quality: 2,
    },
    {
      id: 'pictureUrl',
      name: 'Thumbnail Image',
      type: 'IMAGE',
      extensions: 'image/*',
      multiple: false,
      width: 160,
      height: 160,
      quality: 2,
    },
  ];

  export default {
    name: 'irwChannel',
    components: {
      GoogleAutocomplete,
    },
    data() {
      return {
        metas,
        files: this.initFiles(metas),
        uploading: false,
        config: clone(defaultConfig),
        langs,
        croppa: {},
        cropData: {
          metaId: null,
          source: null,
          image: null,
          showCrop: false,
          width: 100,
          height: 100,
          quality: 4,
        },
        defaultAdSkipButton,
      };
    },
    computed: {
      ...mapState('location', [
        'location',
      ]),
      locationId() {
        return this.location ? this.location.id : null;
      },
      channelId() {
        return this.location ? String(this.location.portal_channel_id) : '';
      },
      mapPreviewUrl() {
        if (!this.config.gmapData.latitude || !this.config.gmapData.longitude) {
          return null;
        }
        return 'https://maps.googleapis.com/maps/api/staticmap?size=300x300'
          + `&zoom=${ this.config.gmapData.zoom }`
          + `&maptype=${ this.config.gmapData.mapTypeId }`
          + `&markers=${ this.config.gmapData.latitude },${ this.config.gmapData.longitude }`
          + `&key=${ googleMapsId }`;
      },
    },
    methods: {
      humanStorageSize,
      initFiles(list) {
        return list.reduce((acc, meta) => {
          acc[meta.id] = [];
          return acc;
        }, {});
      },
      fileCanAdd(metaId) {
        return !this.uploading && this.files[metaId];
      },
      filePick(metaId) {
        if (this.fileCanAdd(metaId) && (this.$q.platform.is.mozilla || this.$q.platform.is.ie)) {
          this.$refs[`file_${ metaId }`][0].click();
        }
      },
      fileAdd(e, meta) {
        const metaId = meta.id;
        const { multiple } = meta;
        if (!this.fileCanAdd(metaId)) {
          return;
        }

        this.cropData.showCrop = false;
        if (!multiple) {
          this.$set(this.files, metaId, []);
        }

        let files = Array.prototype.slice.call(e.target.files);
        this.$refs[`file_${ metaId }`][0].value = '';

        files = files
          .filter((file) => !this.files[metaId].some((f) => file.name === f.name && file.size === f.size))
          .map((file) => this.fileInit(file, metaId));
        let q = Promise.resolve();
        files.forEach((f) => {
          if (f.type.startsWith('image')) {
            q = q.then(() => new Promise((resolve, reject) => {
              const reader = new FileReader();
              reader.onerror = (r) => reject(r);
              reader.onload = (r) => {
                f.__img = r.target.result;
                f.__imgCrop = r.target.result;
                resolve(r);
              };
              reader.readAsDataURL(f);
            }));
          }
        });
        q.then(() => {
          this.$set(this.files, metaId, this.files[metaId].concat(files));
          this.selectForCrop(meta, files[0]);
        });
      },
      fileRemove(metaId, file) {
        if (!this.fileCanAdd(metaId)) {
          return;
        }

        this.cropData.showCrop = false;
        const files = this.files[metaId].slice();
        const fileIndex = files.findIndex((f) => file === f);

        if (fileIndex !== -1) {
          files.splice(fileIndex, 1);
          this.$set(this.files, metaId, files);
        }
      },
      fileInit(file, metaId) {
        fileIdef += 1;
        file.__id = fileIdef;
        file.__checksum = null;
        file.__size = humanStorageSize(file.size);
        file.__doneUploading = false;
        file.__failed = false;
        file.__failedStatus = null;
        file.__uploaded = 0;
        file.__progress = 0;
        file.__progress_checksum = 0;
        file.__promise_checksum = this
          .fileChecksum(file, metaId)
          .then((checksum) => {
            file.__checksum = checksum;
            this.$set(this.files, metaId, [...this.files[metaId]]);
            return checksum;
          })
          .catch(() => {
            file.__progress_checksum = 0;
          });
        return file;
      },
      fileChecksum(file, metaId) {
        return new Promise((resolve, reject) => {
          const blobSlice = File.prototype.slice || File.prototype.mozSlice || File.prototype.webkitSlice;
          const chunks = Math.ceil(file.size / chunkSize);
          const fileReader = new FileReader();
          const crypto = new asmCrypto.SHA256();
          let currentChunk = 0;

          function loadNext() {
            const start = currentChunk * chunkSize;
            const end = ((start + chunkSize) >= file.size) ? file.size : start + chunkSize;
            fileReader.readAsArrayBuffer(blobSlice.call(file, start, end));
          }

          crypto.process([file.name, file.size, uid()].join('#'));

          fileReader.onload = (e) => {
            if (file.__removed) {
              reject();
            } else {
              try {
                crypto.process(e.target.result);
                if (currentChunk < chunkMaxCount || currentChunk > chunks - chunkMaxCount - 1) {
                  currentChunk += 1;
                } else {
                  currentChunk = chunks - chunkMaxCount;
                }
                file.__progress_checksum = (currentChunk * 100) / chunks;
                this.$set(this.files, metaId, [...this.files[metaId]]);
                if (currentChunk < chunks) {
                  loadNext();
                } else {
                  resolve(asmCrypto.bytes_to_hex(crypto.finish().result));
                }
              } catch (err) {
                reject(err);
              }
            }
          };

          fileReader.onerror = (err) => {
            reject(err);
          };

          loadNext();
        });
      },
      startUpload() {
        this.uploading = true;
        this.cropData.showCrop = false;
        let q = Promise.resolve();
        Object.keys(this.files).forEach((metaId) => {
          const meta = this.metas.find((s) => String(s.id) === String(metaId));
          this.files[metaId].forEach((file) => {
            file.__failed = false;
            file.__failedStatus = null;
          });
          q = q.then(() => this.processUpload(meta)).catch(() => true);
        });
        return q.then(() => {
          this.uploading = false;
          return this.files;
        });
      },
      processUpload(meta) {
        const metaId = String(meta.id);
        const files = this.files[metaId]
          .filter((file) => !file.__failed && !file.__removed && !file.__doneUploading && file.__progress_checksum > 0)
          .sort((a, b) => (a.size * (2 - (a.__progress_checksum / 100))) - (b.size * (2 - (b.__progress_checksum / 100))));
        if (!files.length || !this.uploading) {
          return Promise.resolve();
        }
        const file = files[0];
        const fileCropped = file.__crop || file;
        file.__cancelToken = CancelToken.source();
        const uploadPromise = () => new Promise((resolve, reject) => {
          if (!this.uploading || file.__removed || !file.__checksum) {
            return reject(new Error());
          }
          const uploadLength = fileCropped.size;
          let uploadOffset = 0;
          let endpoint = '/upload';
          const upload = (fileId) => {
            if (uploadOffset >= uploadLength) {
              return resolve({ fileId });
            }
            const blob = fileCropped.slice(uploadOffset, uploadOffset + chunkSize);
            return this.$http
              .put(endpoint, blob, {
                cancelToken: file.__cancelToken.token,
                headers: {
                  'Content-Type': file.type || 'application/octet-stream',
                  'Content-Range': `bytes ${ uploadOffset }-${ (uploadOffset + blob.size) - 1 }/${ uploadLength }`,
                },
                noRetry: true,
                onUploadProgress: (progressEvent) => {
                  file.__uploaded = Math.min(uploadLength, uploadOffset + progressEvent.loaded);
                  file.__progress = Math.min(100, (file.__uploaded * 100) / uploadLength);
                  this.$set(this.files, metaId, [...this.files[metaId]]);
                  return progressEvent;
                },
              })
              .then((response) => {
                if (response.status === 201) {
                  return resolve({ fileId });
                }
                uploadOffset = parseRange(response.headers.range);
                return upload(response.data ? response.data.fileId : null);
              })
              .catch((rejection) => {
                if (!isCancel(rejection)) {
                  reject(new Error('Invalid Upload-Offset'));
                }
                return reject(rejection);
              });
          };
          const payload = JSON.stringify({
            id: file.__checksum,
            name: file.name,
            meta: {
              location_id: this.locationId,
              meta_type: meta.name,
            },
          });
          return this.$http
            .post(endpoint, payload, {
              cancelToken: file.__cancelToken.token,
              params: {
                uploadType: 'resumable',
              },
              headers: {
                'X-Upload-Content-Type': fileCropped.type || 'application/octet-stream',
                'X-Upload-Content-Length': fileCropped.size,
                'Content-Type': 'application/json; charset=UTF-8',
              },
              noRetry: true,
            })
            .then((response) => {
              endpoint = parseEndpoint(response.headers.location);
              return endpoint;
            })
            .catch((rejection) => {
              if (rejection.response && rejection.response.status === 409) {
                endpoint = parseEndpoint(rejection.response.headers.location);
                return endpoint;
              }
              return Promise.reject(rejection);
            })
            .then(() => this.$http
              .put(endpoint, null, {
                cancelToken: file.__cancelToken.token,
                headers: {
                  'Content-Range': `*/${ fileCropped.size }`,
                  'Content-Type': fileCropped.type || 'application/octet-stream',
                },
                noRetry: true,
              })
              .then((response) => {
                if (response.status === 206) {
                  uploadOffset = parseRange(response.headers.range);
                  file.__uploaded = uploadOffset;
                  file.__progress = Math.min(100, (file.__uploaded * 100) / uploadLength);
                  this.$set(this.files, metaId, [...this.files[metaId]]);
                  return upload();
                }
                file.__progress = 100;
                this.$set(this.files, metaId, [...this.files[metaId]]);
                return resolve(response);
              }))
            .catch(reject);
        });
        return file.__promise_checksum
          .then(uploadPromise)
          .then(() => {
            file.__doneUploading = true;
            return this.$http
              .post('/resource/create', stringify({
                file: [file.__checksum],
                file_name: [`${ file.__checksum }.${ file.name.split('.').slice(-1).join('').toLowerCase() }`],
                overwrite: false,
                use_id_as_name: true,
                use_name_as_id: false,
                mime_type: fileCropped.type,
                type: meta.type,
                storage_server_id: 14, // public resource
                stop_on_error: true,
                metadata: JSON.stringify({
                  location_id: this.locationId,
                  meta_type: meta.name,
                  meta_id: meta.id,
                  file_name: fileCropped.name,
                  file_size: fileCropped.size,
                  file_type: fileCropped.type,
                  uploaded_timestamp: (new Date()).valueOf(),
                  channel_id: this.channelId,
                }),
                demo: false,
                channel_id: this.channelId,
              }, { arrayFormat: 'brackets' }), {
                headers: {
                  'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8',
                },
              })
              .then((response) => {
                file.__resourceId = response.data.resources[0].resource.id;
                return this.$http
                  .get('/resource/getDetails', { params: { id: file.__resourceId } })
                  .then((response2) => {
                    const __resourceUrl = response2.data.results[0].PUBLIC_LINK || response2.data.results[0].url;
                    file.__resourceUrl = __resourceUrl.replace(/^http:/, 'https:');
                  });
              })
              .catch((rejection) => {
                const msg = getRejectionMessage(rejection, 'There was an error creating resource.');
                if (!isCancel(rejection) && msg.indexOf('Resource already exists') === -1) {
                  showRejectionMessage(rejection, 'There was an error creating resource.');
                }
                return rejection;
              });
          })
          .catch((error) => {
            if (error !== true) {
              file.__failed = true;
              if (typeof error === 'string') {
                file.__failedStatus = error;
              } else if (isCancel(error)) {
                file.__failedStatus = 'Upload cancelled';
              } else {
                file.__failedStatus = getRejectionMessage(error, 'Error uploading - try again');
              }
            }
            return error;
          })
          .then(() => {
            this.$set(this.files, metaId, [...this.files[metaId]]);
            return this.processUpload(meta);
          });
      },
      currentUploadStats(meta) {
        if (meta) {
          return meta.reduce((acc2, file) => {
            acc2.files += 1;
            acc2.total += file.size;
            acc2.uploaded += file.__uploaded;
            acc2.progress = (acc2.uploaded * 100) / acc2.total;
            return acc2;
          }, {
            files: 0,
            total: 0,
            uploaded: 0,
            progress: 0,
          });
        }
        return Object.values(this.files).reduce((acc1, m) => m.reduce((acc2, file) => {
          acc2.files += 1;
          acc2.total += file.size;
          acc2.uploaded += file.__uploaded;
          acc2.progress = (acc2.uploaded * 100) / acc2.total;
          return acc2;
        }, acc1), {
          files: 0,
          total: 0,
          uploaded: 0,
          progress: 0,
        });
      },
      geolocationChanged(place) {
        this.config.gmapData.latitude = place.geometry.location.lat();
        this.config.gmapData.longitude = place.geometry.location.lng();
        this.config.gmapData.address = place.formatted_address;
      },
      selectForCrop(meta, file) {
        const img = new Image();
        img.src = file.__img;
        img.setAttribute('crossorigin', 'anonymous');
        this.cropData.metaId = meta.id;
        this.cropData.width = meta.width;
        this.cropData.height = meta.height;
        this.cropData.quality = meta.quality;
        this.cropData.source = file;
        this.cropData.image = img;
        this.cropData.showCrop = true;
        this.croppa.refresh();
      },
      saveCrop() {
        const { metaId, source } = this.cropData;
        if (metaId && source && this.croppa.hasImage()) {
          const files = this.files[metaId].slice();
          const fileIndex = files.findIndex((f) => source === f);
          if (fileIndex !== -1) {
            this.croppa
              .promisedBlob()
              .then((blob) => {
                blob.lastModifiedDate = new Date();
                blob.name = source.name;
                return this.fileChecksum(blob, metaId)
                  .then((checksum) => {
                    source.__crop = blob;
                    source.__checksum = checksum;
                    source.__imgCrop = this.croppa.generateDataUrl();
                    files.splice(fileIndex, 1, source);
                    this.$set(this.files, metaId, files);
                    this.cropData.showCrop = false;
                  });
              });
          }
        }
      },
      getConfig() {
        if (!this.location) {
          this.setConfigDefault();
          return;
        }
        this.$http
          .get('/channels/list', {
            params: {
              channel_id: this.channelId,
            },
          })
          .then((response) => {
            const channel = response.data.results.length ? response.data.results[0] : {};
            let config = {};
            try {
              config.title = channel.TITLE || '';
              config.description = channel.DESCRIPTION || '';
              config.eventDate = channel.EVENT_DATE ? new Date(channel.EVENT_DATE) : new Date();
              config.gmapData = extend({
                mapTypeId: 'roadmap',
                zoom: 16,
                latitude: 0,
                longitude: 0,
                address: '',
              }, channel.GMAP_DATA ? JSON.parse(channel.GMAP_DATA) : {});
              config.gmapData.zoom = parseInt(config.gmapData.zoom, 10) || 16;
              config.gmapData.latitude = parseFloat(config.gmapData.latitude) || 0;
              config.gmapData.longitude = parseFloat(config.gmapData.longitude) || 0;

              config.adConfig = extend({}, defaultAdConfig, channel.AD_CONFIG ? JSON.parse(channel.AD_CONFIG) : {});

              config.bannerUrl = channel.BANNER_URL || '';
              config.pictureUrl = channel.PICTURE_URL || '';
              config.demoVideoId = channel.DEMO_VIDEO_ID;

              config.publish = channel.PUBLISH ? 1 : 0;
              config.featured = channel.FEATURED ? 1 : 0;
              config.channelType = channel.CHANNEL_TYPE;
              config.status = channel.STATUS ? 1 : 0;
              config.categoryId = channel.CATEGORY_ID;

              config.demo_thumbnail_url = channel.demo_thumbnail_url || '';

              config.dashboardUrl = channel.dashboard_url || '';
              config.gaCode = channel.ga_code || 'UA-43608838-6';

              config.iframeHtmlCode = channel.iframe_html_code;
              config.iframeContainerUrl = channel.iframe_container_url;

              config.shareTemplateKey = channel.share_template_key;
              config.sendgridCredentialsId = channel.sendgrid_credentials_id;
            } catch (e) {
              config = clone(defaultConfig);
            }
            this.config = config;
            return response;
          })
          .catch((rejection) => {
            if (!isCancel(rejection)) {
              showRejectionMessage(rejection, 'There was an error reading channel info.');
            }
            this.setConfigDefault();
            return Promise.reject(rejection);
          });
      },
      setConfigDefault() {
        const config = clone(defaultConfig);
        this.config = config;
      },
      saveConfig() {
        const payload = {
          channel_id: this.channelId,
          title: this.config.title,
          description: this.config.description,
          event_date: this.config.eventDate ? this.config.eventDate.valueOf() : null,
          gmap_data: JSON.stringify(this.config.gmapData),
          ad_config: JSON.stringify(this.config.adConfig),
          publish: this.config.publish,
          featured: this.config.featured,
          dashboard_url: this.config.dashboardUrl,
          iframe_container_url: this.config.iframeContainerUrl,
          demo_thumbnail_url: this.config.demo_thumbnail_url,
          ga_code: this.config.gaCode,
        };
        return this
          .startUpload()
          .then((files) => {
            if (files.bannerUrl.length && files.bannerUrl[0].__resourceUrl) {
              payload.banner_url = files.bannerUrl[0].__resourceUrl;
            }
            if (files.pictureUrl.length && files.pictureUrl[0].__resourceUrl) {
              payload.picture_url = files.pictureUrl[0].__resourceUrl;
            }
            return this.$http
              .post('/channel/update', stringify(payload, { arrayFormat: 'brackets' }), {
                headers: {
                  'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8',
                },
              });
          })
          .then(() => {
            this.$q.notify({
              type: 'positive',
              message: 'Configuration saved',
              position: 'bottom-right',
            });
          })
          .catch((rejection) => {
            if (rejection.response) {
              showRejectionMessage(rejection, 'Error saving configuration');
            }
          });
      },
    },
    watch: {
      location() {
        this.files = this.initFiles(this.metas);
        this.getConfig();
      },
    },
    mounted() {
      this.files = this.initFiles(this.metas);
      this.getConfig();
    },
  };
</script>
